package de.ozgcloud.nachrichten.postfach;

import org.mapstruct.Mapper;
import org.mapstruct.Mapping;

import de.ozgcloud.vorgang.common.GrpcObject;
import de.ozgcloud.vorgang.common.grpc.GrpcObjectMapper;

@Mapper(uses = GrpcObjectMapper.class)
public interface GrpcPostfachNachrichtMapper {

	@Mapping(target = "attachments", source = "attachmentList")
	@Mapping(target = "createdAt", ignore = true)
	@Mapping(target = "createdBy", ignore = true)
	@Mapping(target = "direction", constant = "OUT")
	@Mapping(target = "messageCode", ignore = true)
	@Mapping(target = "messageId", ignore = true)
	@Mapping(target = "sentAt", ignore = true)
	@Mapping(target = "sentSuccessful", ignore = true)
	@Mapping(target = "vorgangId", ignore = true)
	PostfachNachricht mapFromGrpc(GrpcPostfachNachricht nachricht);

	default PostfachAddressIdentifier map(GrpcObject value) {
		return StringBasedIdentifier.builder().postfachId(value.getProperty(0).getValue(0)).build();
	}
}
