package de.ozgcloud.nachrichten.common.vorgang;

import java.util.UUID;

import de.ozgcloud.vorgang.common.GrpcObject;
import de.ozgcloud.vorgang.common.GrpcProperty;
import de.ozgcloud.vorgang.vorgang.GrpcPostfachAddress;

public class GrpcPostfachAddressTestFactory {

	public static final String IDENTIFIER_POSTFACH_ID_FIELD = "postfachId";
	public static final String STRING_BASED_IDENTIFIER_POSTFACH_ID_VALUE = UUID.randomUUID().toString();

	public static GrpcPostfachAddress create() {
		return createBuilder().build();
	}

	public static GrpcPostfachAddress.Builder createBuilder() {
		return GrpcPostfachAddress.newBuilder()
				.setIdentifier(createStringBasedIdentifier());
	}

	private static GrpcObject createStringBasedIdentifier() {
		return GrpcObject.newBuilder()
				.addProperty(GrpcProperty.newBuilder()
						.setName(IDENTIFIER_POSTFACH_ID_FIELD)
						.addValue(STRING_BASED_IDENTIFIER_POSTFACH_ID_VALUE)
						.build())
				.build();
	}
}
